import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'camera_permission.dart';

import 'camera_device.dart';
import 'vital_sign_camera_method_channel.dart';

abstract class VitalSignCameraPlatform extends PlatformInterface {
  /// Constructs a VitalSignCameraPlatform.
  VitalSignCameraPlatform() : super(token: _token);

  static final Object _token = Object();

  static VitalSignCameraPlatform _instance = MethodChannelVitalSignCamera();

  /// The default instance of [VitalSignCameraPlatform] to use.
  ///
  /// Defaults to [MethodChannelVitalSignCamera].
  static VitalSignCameraPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [VitalSignCameraPlatform] when
  /// they register themselves.
  static set instance(VitalSignCameraPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<List<CameraDevice>> availableCameraDevices() {
    throw UnimplementedError(
        'availableCameraDevices() has not been implemented.');
  }

  Future<CameraPermissionStatus> requestCameraPermission() {
    throw UnimplementedError(
        'availableCameraDevices() has not been implemented.');
  }

  Future<CameraPermissionStatus> getCameraPermissionStatus() {
    throw UnimplementedError(
        'getCameraPermissionStatus() has not been implemented.');
  }
}
